#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// 
    /// </summary>
    [Description("")]
    public class TASCDonchian : Indicator
    {
        #region Variables
        // Wizard generated variables
        // User defined variables (add any user defined variables below)
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            Add(new Plot(Color.FromKnownColor(KnownColor.Green), PlotStyle.Line, "LongUpper"));
            Add(new Plot(Color.FromKnownColor(KnownColor.Violet), PlotStyle.Line, "ShortUpper"));
            Add(new Plot(Color.FromKnownColor(KnownColor.Violet), PlotStyle.Line, "ShortLower"));
            Add(new Plot(Color.FromKnownColor(KnownColor.Green), PlotStyle.Line, "LongLower"));
            Overlay				= true;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
            // Use this method for calculating your indicator values. Assign a value to each
            // plot below by replacing 'Close[0]' with your own formula.
            LongUpper.Set(MAX(High, 40)[0]);
            ShortUpper.Set(MAX(High, 15)[0]);
            ShortLower.Set(MIN(Low, 15)[0]);
            LongLower.Set(MIN(Low, 40)[0]);
        }

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries LongUpper
        {
            get { return Values[0]; }
        }

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries ShortUpper
        {
            get { return Values[1]; }
        }

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries ShortLower
        {
            get { return Values[2]; }
        }

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries LongLower
        {
            get { return Values[3]; }
        }

        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private TASCDonchian[] cacheTASCDonchian = null;

        private static TASCDonchian checkTASCDonchian = new TASCDonchian();

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public TASCDonchian TASCDonchian()
        {
            return TASCDonchian(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public TASCDonchian TASCDonchian(Data.IDataSeries input)
        {
            if (cacheTASCDonchian != null)
                for (int idx = 0; idx < cacheTASCDonchian.Length; idx++)
                    if (cacheTASCDonchian[idx].EqualsInput(input))
                        return cacheTASCDonchian[idx];

            lock (checkTASCDonchian)
            {
                if (cacheTASCDonchian != null)
                    for (int idx = 0; idx < cacheTASCDonchian.Length; idx++)
                        if (cacheTASCDonchian[idx].EqualsInput(input))
                            return cacheTASCDonchian[idx];

                TASCDonchian indicator = new TASCDonchian();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                TASCDonchian[] tmp = new TASCDonchian[cacheTASCDonchian == null ? 1 : cacheTASCDonchian.Length + 1];
                if (cacheTASCDonchian != null)
                    cacheTASCDonchian.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheTASCDonchian = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.TASCDonchian TASCDonchian()
        {
            return _indicator.TASCDonchian(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.TASCDonchian TASCDonchian(Data.IDataSeries input)
        {
            return _indicator.TASCDonchian(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.TASCDonchian TASCDonchian()
        {
            return _indicator.TASCDonchian(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.TASCDonchian TASCDonchian(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.TASCDonchian(input);
        }
    }
}
#endregion
